<?php include_once('../init.php'); 
/* SVN FILE: $Id: settings_mail.php 481 2014-01-12 15:37:05Z anders $
* Project Name : ThermIQ*
* @version $Revision: 481 $
* @lastrevision $Date: 2014-01-12 16:37:05 +0100 (sön, 12 jan 2014) $
* @modifiedby $LastChangedBy: anders $
* @lastmodified $LastChangedDate: 2014-01-12 16:37:05 +0100 (sön, 12 jan 2014) $
*/
// Date format
$dateformat = "Y-m-d H:i:s";       // Date format. Here are some other examples (that you can combine) :
                                   // "M D, Y"   = Dec Fri, 2002
                                   // "m/d/y"    = 12/20/02
                                   // "m-d-y"    = 12-20-02
                                   // "l M d, Y" = Friday Dec 20, 2002
                                   // "F dS, Y"  = December 20th, 2002
                                   // "H:i:s"    = 24 hour time with seconds
                                   // "h:i a"    = 12 hour time with am,pm
                                   // etc...

// Header
		header("Expires: -1");
		header("Pragma: no-cache");
		header("Cache-Control: max-age=0");
		header("Cache-Control: no-cache");
		header("Cache-Control: no-store");
		header("Content-Type: text/html; charset=iso-8859-1");


		echo "\n<html>";
		echo "\n<head>";
		echo "<meta name=\"revised\" content=\"\$Revision: 481 $\" />";
		
		echo "\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">";
		echo "\n<title>".$ui_string['settings']['page_name']."</title>";
		echo "\n<style type=\"text/css\" media=screen>";
		echo "\n<!--";
		echo "\ntd         { background-color: #F0F0F0; color: #000000; font-family: Arial, Helvetica, sans-serif; font-size: 10pt; }";
		echo "\n-->";
		echo "\n</style>";
		echo "<LINK href=\"style.css\" rel=\"stylesheet\" type=\"text/css\">\n";
		echo '<script type="text/JavaScript" src="curvycorners.js"></script>'."\n";

		
		echo "\n</head><body>";
		$sel_page=9;
		include('toplinks.php');
		
		
// Table
		echo '<div id="Panel" style="position:relative;z-index:0;left:0px;top:20px;width:955px;background-color:#f0f0f0;border:2px outset grey;">'."\n";
		echo '<b>'.$ui_string['settings']['mail_tbl'];
		echo "</b><br>".date($dateformat).'<br></div><br><br>';

// Buttons
	  echo '<INPUT STYLE="width:130" TYPE="BUTTON" VALUE="'.$ui_string['settings']['back_btn'].'" NAME="CANCEL"';
    echo " ONCLICK=\"location.href='settings.php';return false;\"><br><br>";
    if ($admin) {

// Support functions
   function read_ini_filex($f)
    {global $r;
        $null = "";
        $r=$null;
        $first_char = "";
        $sec=$null;
        $comment_chars=";#";
        $num_comments = "0";
        $num_newline = "0";
        //Read to end of file with the newlines still attached into $f
        $f = @file($f);
        if ($f === false) {
            return -2;
        }
        // Process all lines from 0 to count($f)
        for ($i=0; $i<@count($f); $i++)
        {
            $w=@trim($f[$i]);
            $first_char = @substr($w,0,1);
            if ($w)
            {
                if ((@substr($w,0,1)=="[") and (@substr($w,-1,1))=="]") {
                    $sec=@substr($w,1,@strlen($w)-2);
                    $num_comments = 0;
                    $num_newline = 0;
                }
                else if ((stristr($comment_chars, $first_char) == true)) {
                    $r[$sec]["Comment_".$num_comments]=$w;
                    $num_comments = $num_comments +1;
                }               
                else {
                    // Look for the = char to allow us to split the section into key and value
                    $w=@explode("=",$w);
                    $k=@trim($w[0]);
                    unset($w[0]);
                    $v=@trim(@implode("=",$w));
                    // look for the new lines
                    if ((@substr($v,0,1)=="\"") and (@substr($v,-1,1)=="\"")) {
                        $v=@substr($v,1,@strlen($v)-2);
                    }
                    $r[$sec][$k]=$v;
                }
            }
            else {
                $r[$sec]["Newline_".$num_newline]=$w;
                $num_newline = $num_newline +1;
            }
        }
        return 1;
    }
    function write_ini_filex($path, $assoc_arr) {
        $content = "";
        foreach ($assoc_arr as $key=>$elem) {
            if (is_array($elem)) {
                if ($key != '') {
                    $content .= "[".$key."]\r\n";                   
                }
                foreach ($elem as $key2=>$elem2) {
                    if (beginsWith($key2,'Comment_') == 1 && beginsWith($elem2,';')) {
                        $content .= $elem2."\r\n";
                    }
                    else if (beginsWith($key2,'Newline_') == 1 && ($elem2 == '')) {
                        $content .= $elem2."\r\n";
                    }
                    else {
                        $content .= $key2." = ".$elem2."\r\n";
                    }
                }
            }
            else {
                $content .= $key." = ".$elem."\r\n";
            }
        }
        if (!$handle = fopen($path, 'w')) {
            return -2;
        }
        if (!fwrite($handle, $content)) {
            return -2;
        }
        fclose($handle);
        return 1;
    }
    function beginsWith( $str, $sub ) {
        return ( substr( $str, 0, strlen( $sub ) ) === $sub );
    }
// set file to read
if (isset($settings['misc']['mail_rc_file'])) {
		$filename=$settings['misc']['mail_rc_file'];
} else {
	if (strstr(php_uname('s'),'Linux')) {
		$filename ='/root/.msmtprc';
	} else {
		$filename ='C:/xampp/sendmail/sendmail.ini';
	}
}

$mailargs=$settings['misc']['permdir'] . 'mailargs';
list($MAILALM,$SMTP,$ADR1,$ADR2,$FROM,$SUBJ)=explode(':',file_get_contents($mailargs));

    if (!empty($_POST)) {
 	//foreach($_POST as $key => $value) echo($key.'  '.$value.'<br>');
			extract($_POST);
   	  if (isset($_POST['OK'])) {
   	  	if (strstr(php_uname('s'),'Linux')) {
					$inifile=$opt_path.'Thermiq_Linux.ini';
				}
				else if(strstr(php_uname('s'),'Windows')) {
					$inifile=$opt_path.'Thermiq_Windows.ini';	
				} else {
					echo "<br><b>Unknown OS, nothing is changed:</b></br>";
				} 
	 		 	read_ini_filex($inifile);
	    	if(!isset($_POST['MAILALM'])) {
	    		$MAILALM = '';
	    		$r['misc']['mail_system']= '';
	    		$settings['misc']['mail_system']='';
	    	} else {
	    		$r['misc']['mail_system']= 'enabled';
	    		$settings['misc']['mail_system']='enabled';
				} 
				if (strstr(php_uname(),'raspberrypi')) {
		    	if(!isset($_POST['MAIL_RC'])) {
		    		$r['misc']['mail_rc_file']= '';
		    		$settings['misc']['mail_rc_file']='';
		    	} else {
		    		$r['misc']['mail_rc_file']= $_POST['MAIL_RC'];
		    		$settings['misc']['mail_rc_file']=$_POST['MAIL_RC'];		    		
		    	}
		    	$filename=$settings['misc']['mail_rc_file'];
				}
				write_ini_filex($inifile,$r);
	  			file_put_contents($mailargs,"$MAILALM:$SMTP:$ADR1:$ADR2:$FROM:$SUBJ");
	  	}
			if (isset($_POST['ERASE'])) {
				$tim = time();
				$permdb->beginTransaction();
				$permdb->exec('delete from alarmlog');
				$permdb->exec("insert into alarmlog values ($tim,0,0)");
				$permdb->commit();
			}
			if (isset($_POST['TEST'])) exec($php_prepend . 'alarm_handler 127 127');
			if (isset( $_POST['NEWD'])) {
				$newdata = $_POST['NEWD'];
				// open file 
				$fw = fopen($filename, 'w') or die('Could not open file! '.$filename);
				// write to file
				// added stripslashes to $newdata
				$fb = fwrite($fw,$newdata) or die('Could not write to file');
				// close file
				fclose($fw);
			}
		} 
  }

echo '<DIV">
<FORM ';
if(!$admin) echo 'DISABLED';
echo ' METHOD="POST" NAME="Grafer" ACTION="settings_mail.php">';
echo '<div class="valuePanel" id="Panely" style="position:relative;z-index:0;left:0px;top:20px;width:950px;background-color:#f0f0f0;border:2px outset grey;">'."\n";
if($admin) echo '<INPUT STYLE="WIDTH:120" NAME="OK" TYPE="SUBMIT" VALUE="'.$ui_string['larmlogg']['store'].'">';
echo '<TABLE BORDER=0 cellspacing=0 BORDERCOLOR=Grey cellpadding=3  style="font-size:15;">
<TR BORDER=0>
<TD BORDER=0><INPUT NAME="MAILALM" VALUE="checked" TYPE="CHECKBOX" ';
if ($settings['misc']['mail_system']=='enabled') echo 'checked'; 
echo ' >';
echo $ui_string['larmlogg']['emailq'];
echo '</TD>
<TD></TD><TD></TD>
<TD></TD><TD></TD>
</TR>
<TR>
<TD ALIGN="RIGHT">';
echo $ui_string['larmlogg']['emailto'];
echo '1: </TD>
<TD WIDTH="200"><INPUT NAME="ADR1"  VALUE="';
echo $ADR1;
echo '" TYPE="TEXT" SIZE="25"></TD>
<TD ALIGN="RIGHT">';
echo $ui_string['larmlogg']['emailfrom']; 
echo '</TD>
<TD><INPUT NAME="FROM" VALUE="';
echo $FROM;
echo '" TYPE="TEXT" SIZE="25"></TD>
<TD ALIGN="RIGHT" WIDTH="120">';
  //if ($admin) echo '<INPUT STYLE="WIDTH:120" NAME="CANCEL" TYPE="RESET" VALUE="'.$ui_string['larmlogg']['dontstore'].'">';

echo '</TD>
</TR>
<TR>
<TD ALIGN="RIGHT">';
echo $ui_string['larmlogg']['emailto'];
echo ' 2: </TD>
<TD><INPUT NAME="ADR2" VALUE="';
echo $ADR2;
echo '" TYPE="TEXT" SIZE="25"></TD>
<TD ALIGN="RIGHT">';
echo $ui_string['larmlogg']['emailsubject'];
echo ': </TD>
<TD><INPUT NAME="SUBJ" VALUE="';
echo $SUBJ;
echo '" TYPE="TEXT" SIZE="25"></TD>
<TD ALIGN="RIGHT">';

echo '</TD>
</TR>';
	if (strstr(php_uname(),'raspberrypi')) {
  
		$mail_rc='';
		if (isset($settings['misc']['mail_rc_file'])) $mail_rc=$settings['misc']['mail_rc_file'];

		echo '<Td ALIGN="RIGHT">Mail config file:</td><td><INPUT NAME="MAIL_RC" VALUE="'. $mail_rc. '" TYPE="TEXT" SIZE="25"></td>';
	}
echo '</TABLE></FORM></div>';



// open file
  $fh = fopen($filename, "r") or die("Could not open file!".$filename);
// read file contents
  $data = fread($fh, filesize($filename)) or die("Could not read file!".$filename);
// close file
  fclose($fh);
// Only do remaining boxes if mail is enabled
    $display = 'NONE';
    if ($settings['misc']['mail_system']<>'') $display='inline';
echo '<div class="mailpanel" style="display:'.$display.';">';
	echo '<div class="valuePanel" id="Panelx" style="position:relative;z-index:0;left:0px;top:20px;width:950px;background-color:#f0f0f0;border:2px outset grey;">'."\n";

 echo "<b>&nbsp;Mail config file content</b>
<form action=settings_mail.php method= 'post'>
<input STYLE=\"WIDTH:120\" type='submit' value='".$ui_string['larmlogg']['store']."'><br><br>
<textarea name='NEWD' style=\"position:relative;z-index:1;left:10px;width:935px;height:220px\">$data</textarea>
</form>
</DIV><br>";

	echo '<div class="valuePanel" id="Panel" style="position:relative;z-index:0;left:0px;top:20px;width:950px;background-color:#f0f0f0;border:2px outset grey;">'."\n";
  if($admin){
  echo '<FORM METHOD="POST" NAME="Knappar" ACTION="settings_mail.php">';
  echo '<TABLE><TR><TD WIDTH="120"><INPUT STYLE="WIDTH:140" NAME="ERASE" TYPE="SUBMIT" VALUE="'.$ui_string['larmlogg']['clearlog'].'"></TD>';
  echo '<TD WIDTH="120"><INPUT STYLE="WIDTH:140" NAME="TEST" TYPE="SUBMIT" VALUE="'.$ui_string['larmlogg']['test'].'"></TD>';
	echo '</TR></TABLE></FORM>';

  }

echo '<div id="larmpanel" style="position:relative;z-index:1;left:10px;top:0px;">'."<textarea name='larmlogg' cols='113' rows='20'>";

$alm_ary = null;
$reg_ary = null;
  foreach($permdb->query('select * from alarmlog') as $row) {
  $alm_ary[] = $row;
  }
  $alm_cnt=0;
  if(!is_null($alm_ary)) {
    foreach($tempdb->query('select regname,regnum,regbit from regdata where (regnum=19 or regnum=20)') as $row) {
    extract($row);
    $reg_ary[$REGNUM][$REGBIT] = $ui_string['regcap'][$REGNAME];
    }
    foreach($alm_ary as $row) {
    $alm_cnt+=1;
    extract ($row);
    $tim=strftime('%c',$TID); 
      if($ALM1 == 0 && $ALM2 == 0){
      echo "$tim\t".$ui_string['larmlogg']['startlog']."\n";
      }
      else
      {
        foreach($reg_ary as $reg => $bits) {
          foreach($bits as $bit => $capt) {
            if(($reg == 19?$ALM1:$ALM2) & (1<<($bit-1))) echo "$tim\t$capt\n";
          }
        }
      }
    }
  }
  echo "\t-- end --\n";
echo '</textarea></br>';
// open file
	if (strstr(php_uname('s'),'Linux')) {
		$filename ='/tmp/sendmail.log';
	} else {
		$filename ='C:/xampp/sendmail/sendmail.log';
	}
if (file_exists($filename) ) {
$data = array_slice(file($filename), -5);
echo '<textarea id="maillogg" cols="113" rows="10">';
foreach ($data as $line) {
    echo $line;
}
echo '</textarea>
<script type="text/javascript">
var textarea = document.getElementById(\'maillogg\');
textarea.scrollTop = textarea.scrollHeight;
</script>';
}
echo '
</div></div></body>
</html>

';

$tempdb = null;
$permdb = null;
?>
