<?php 
/* SVN FILE: $Id: settings_pollers.php 497 2014-02-06 20:41:12Z anders $
* Project Name : ThermIQ*
* @version $Revision: 497 $
* @lastrevision $Date: 2014-02-06 21:41:12 +0100 (tor, 06 feb 2014) $
* @modifiedby $LastChangedBy: anders $
* @lastmodified $LastChangedDate: 2014-02-06 21:41:12 +0100 (tor, 06 feb 2014) $
*/
include_once('../init.php');
    

// Date format
$dateformat = "Y-m-d H:i:s";       // Date format. Here are some other examples (that you can combine) :
                                   // "M D, Y"   = Dec Fri, 2002
                                   // "m/d/y"    = 12/20/02
                                   // "m-d-y"    = 12-20-02
                                   // "l M d, Y" = Friday Dec 20, 2002
                                   // "F dS, Y"  = December 20th, 2002
                                   // "H:i:s"    = 24 hour time with seconds
                                   // "h:i a"    = 12 hour time with am,pm
                                   // etc...

// Header
		header("Expires: -1");
		header("Pragma: no-cache");
		header("Cache-Control: max-age=0");
		header("Cache-Control: no-cache");
		header("Cache-Control: no-store");
		header("Content-Type: text/html; charset=iso-8859-1");


		echo "\n<html>";
		echo "\n<head>";
		echo "<meta name=\"revised\" content=\"\$Revision: 497 $\" />";
		
		echo "\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">";
		echo "\n<title>".$ui_string['settings']['page_name']."</title>";
		echo "\n<style type=\"text/css\" media=screen>";
		echo "\n<!--";
		echo "\ntd         { background-color: #F0F0F0; color: #000000; font-family: Arial, Helvetica, sans-serif; font-size: 10pt; }";
		echo "\n-->";
		echo "\n</style>";
		echo "<LINK href=\"style.css\" rel=\"stylesheet\" type=\"text/css\">\n";

		
		echo "\n</head>";
		echo '<script type="text/JavaScript" src="curvycorners.js"></script>'."\n";

		
		$sel_page=10;
		include('toplinks.php');
		
// Table
		echo '<div style="position:relative;z-index:0;left:0px;top:20px;width:955px;background-color:#f0f0f0;border:2px outset grey;">'."\n";
		echo '<b>'.$ui_string['settings']['poller_txt'];
		echo "</b><br>".date($dateformat).'<br></div><br><br>';


// Buttons
	  echo '<INPUT STYLE="width:130" TYPE="BUTTON" VALUE="'.$ui_string['settings']['back_btn'].'" NAME="CANCEL"';
    echo " ONCLICK=\"location.href='settings.php';return false;\"><br>\n";

    if ($admin) {
// Buttons
    	
  function read_ini_filex($f)
    {global $r;
        $null = "";
        $r=$null;
        $first_char = "";
        $sec=$null;
        $comment_chars=";#";
        $num_comments = "0";
        $num_newline = "0";

        //Read to end of file with the newlines still attached into $f
        $f = @file($f);
        if ($f === false) {
            return -2;
        }
        // Process all lines from 0 to count($f)
        for ($i=0; $i<@count($f); $i++)
        {
            $w=@trim($f[$i]);
            $first_char = @substr($w,0,1);
            if ($w)
            {
                if ((@substr($w,0,1)=="[") and (@substr($w,-1,1))=="]") {
                    $sec=@substr($w,1,@strlen($w)-2);
                    $num_comments = 0;
                    $num_newline = 0;
                }
                else if ((stristr($comment_chars, $first_char) == true)) {
                    $r[$sec]["Comment_".$num_comments]=$w;
                    $num_comments = $num_comments +1;
                }               
                else {
                    // Look for the = char to allow us to split the section into key and value
                    $w=@explode("=",$w);
                    $k=@trim($w[0]);
                    unset($w[0]);
                    $v=@trim(@implode("=",$w));
                    // look for the new lines
                    if ((@substr($v,0,1)=="\"") and (@substr($v,-1,1)=="\"")) {
                        $v=@substr($v,1,@strlen($v)-2);
                    }
                   
                    $r[$sec][$k]=$v;
                   
                }
            }
            else {
                $r[$sec]["Newline_".$num_newline]=$w;
                $num_newline = $num_newline +1;
            }
        }
        return 1;
    }


    function write_ini_filex($path, $assoc_arr) {
        $content = "";

        foreach ($assoc_arr as $key=>$elem) {
            if (is_array($elem)) {
                if ($key != '') {
                    $content .= "[".$key."]\r\n";                   
                }
               
                foreach ($elem as $key2=>$elem2) {
                    if (beginsWith($key2,'Comment_') == 1 && beginsWith($elem2,';')) {
                        $content .= $elem2."\r\n";
                    }
                    else if (beginsWith($key2,'Newline_') == 1 && ($elem2 == '')) {
                        $content .= $elem2."\r\n";
                    }
                    else {
                        $content .= $key2." = ".$elem2."\r\n";
                    }
                }
            }
            else {
                $content .= $key." = ".$elem."\r\n";
            }
        }

        if (!$handle = fopen($path, 'w')) {
            return -2;
        }
        if (!fwrite($handle, $content)) {
            return -2;
        }
        fclose($handle);
        return 1;
    }

    function beginsWith( $str, $sub ) {
        return ( substr( $str, 0, strlen( $sub ) ) === $sub );
    }


	include('../init.php'); 

if (!empty($_POST)) {

	if (strstr(php_uname('s'),'Linux')) {
		$filename=$opt_path.'Thermiq_Linux.ini';
	}
	else if(strstr(php_uname('s'),'Windows')) {
			$filename=$opt_path.'Thermiq_Windows.ini';	
	} else {
		echo "<br><b>Unknown OS, nothing is changed:</b></br>";
	} 
 	read_ini_filex($filename);
 	$r['ElectrIQ']['poller_ElectrIQ']=0;
 	
 	
/* 	foreach($_POST as $key => $value) {
 		echo($key.'  '.$value.'<br>');
 	}*/

//ThermIQ poller
  if (isset($_POST['poller_mode']) && ($_POST['poller_mode']=='IP'))  $r['misc']['poller_mode']='IP'; else $r['misc']['poller_mode']='COM';
  $ipadr="IP:";
  if (isset($_POST['IP_Address']) && $_POST['IP_Address']!="") { $ipadr.=$_POST['IP_Address'];
  if (isset($_POST['IP_Port'])    && $_POST['IP_Port']!="")     $ipadr.=":".$_POST['IP_Port']; else $ipadr.=":2000";
  if (isset($_POST['IP_User']) && ($_POST['IP_User']!="") )  {
  		$ipadr.=":".$_POST['IP_User'].":";
  		if (isset($_POST['IP_Password']) && ($_POST['IP_Password']!=""))  $ipadr.=$_POST['IP_Password'];
  }}
 	$r['misc']['ip_device']=$ipadr;

  if (isset($_POST['com_device']) && $_POST['com_device']!="") { 
  	$r['misc']['com_device']=$_POST['com_device'];
  }

//Telldus poller
if (isset($settings['Telldus']['poller_telldusduo'])){
  if ($_POST['Telldus_poll']=='ON')  $r['Telldus']['poller_telldusduo']='1'; else $r['Telldus']['poller_telldusduo']='0';
  if (isset($_POST['tdtool_path']))  $r['Telldus']['tdtool_path']=$_POST['tdtool_path'];
 }
 
//ElectrIQ poller
if (isset($settings['ElectrIQ']['poller_ElectrIQ'])){
  if (isset($_POST['EL_poll']) && ($_POST['EL_poll']=='ON'))  $r['ElectrIQ']['poller_ElectrIQ']='1'; else $r['ElectrIQ']['poller_ElectrIQ']='0';

  if (isset($_POST['EL_Ticks']) && is_numeric($_POST['EL_Ticks']))  $r['ElectrIQ']['TicksPerWatt']=$_POST['EL_Ticks']; else $r['ElectrIQ']['TicksPerWatt']='1000';

  $ipadr="IP:";
  if (isset($_POST['EL_Address']) && $_POST['EL_Address']!="")  $ipadr.=$_POST['EL_Address']; {
  if (isset($_POST['EL_Port'])    && $_POST['EL_Port']!="")     $ipadr.=":".$_POST['EL_Port']; else $ipadr.=":2000";
  if (isset($_POST['EL_User']) && ($_POST['EL_User']!="") )  {
  		$ipadr.=":".$_POST['EL_User'].":";
  		if (isset($_POST['EL_Password']) && ($_POST['EL_Password']!=""))  $ipadr.=$_POST['EL_Password'];
  }}
 	$r['ElectrIQ']['ip_device']=$ipadr;
}
//AirIQ poller
if (isset($settings['AirIQ']['poller_AirIQ'])){
  if (isset($_POST['AIR_poll']) && ($_POST['AIR_poll']=='ON'))  $r['AirIQ']['poller_AirIQ']='1'; else $r['AirIQ']['poller_AirIQ']='0';


  $ipadr="IP:";
  if (isset($_POST['AIR_Address']) && $_POST['AIR_Address']!="")  $ipadr.=$_POST['AIR_Address']; {
  if (isset($_POST['AIR_Port'])    && $_POST['AIR_Port']!="")     $ipadr.=":".$_POST['AIR_Port']; else $ipadr.=":2000";
  if (isset($_POST['AIR_User']) && ($_POST['AIR_User']!="") )  {
  		$ipadr.=":".$_POST['AIR_User'].":";
  		if (isset($_POST['AIR_Password']) && ($_POST['AIR_Password']!=""))  $ipadr.=$_POST['AIR_Password'];
  }}
 	$r['AirIQ']['ip_device']=$ipadr;
}

	write_ini_filex($filename,$r);
	$wrote_inifile=$filename;
	$update_db=false;
	$cur_errlvl=error_reporting();
	error_reporting(0);
	
	$update_db |=$r['ElectrIQ']['poller_ElectrIQ']!=$settings['ElectrIQ']['poller_ElectrIQ'];
	$update_db |=$r['AirIQ']['poller_AirIQ']!=$settings['AirIQ']['poller_AirIQ'];
	$update_db |=$r['Telldus']['poller_telldusduo']!=$settings['Telldus']['poller_telldusduo'];
  error_reporting($cur_errlvl);
 	if ($update_db) {
 		exec($php_prepend .'mkdbtemplate',$outlog);
 		$this_output="<b>mkdbtemplate</b></br>";
 		foreach ($outlog as $row) {
				$this_output.= $row ."</br>";
		}

 		$outlog=$this_output;
 	}



	include('../init.php'); 

}	
	
	
}
echo '<script type="text/javascript"></script><noscript><strong><br><span style="color:red">Your browser either does not support JavaScript or it is turned off.';
echo '<br>Without Javascript enabled, this form will not function correctly</strong></span></noscript>';

echo "\n\n";
echo '<form name="New_Form" action="settings_pollers.php" method="POST" enctype="application/x-www-form-urlencoded">';
echo "\n\n";
echo $ui_string['settings']['poller_txt2']."</br></br></br>\n";

echo '<div id="PollerForm" style="position:relative;left:0px;top:60px;width:841px;height:540px;background-color:#FFFFFF;color:#000000;border-width:0;border-style:solid;">';
echo '<form name="New_Form" action="settings_poller.php" method="POST" enctype="application/x-www-form-urlencoded" onsubmit="return New_Form_CF();">';


// Buttons
echo '<input type="submit" onClick="return confirm(\'Really save settings?\');" name="submitBtn" value="Save" tabindex="1" style="position:absolute;z-index:4;left:0px;top:-75px;width:130px;height:24px;">';
echo '<input type="reset" name="resetBtn" value="reset" tabindex="2" style="position:absolute;z-index:5;left:130px;top:-75px;width:130px;height:24px;">';

// ThermIQ Comport or WLAN
echo '<div  class="valuePanel" id="pollers1" style="position:relative;z-index:2;left:10px;width:840px;background:#F0F0F0;border-width:1;border-style:solid;border-color:#FF0000;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;">'."\n";
echo '<div id="pollers1.1" style="position:relative;z-index:27;left:10px;top:10px;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;text-align////:left;color:#000000;">';
echo 'ThermIQ poller:<br><br>';
echo '<input type="radio" name="poller_mode" value="COM" ';if (strtolower($settings['misc']['poller_mode'])=='com') echo('checked'); echo '>Use this com-port for polling ThermIQ<br>';

echo '<input type="text" name="com_device" value="'.$settings['misc']['com_device'].'" size="40" maxlength="75" tabindex="12" style="width:191px;height:22px;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;color:#000000;background-color:#FFFFFF;">';
echo '</br>';
$ip=explode(":",$settings['misc']['ip_device']);
$i=1;
while ($i<5) {
	if (!isset($ip[$i]) ) {
		$ip[$i]='';
	}
		$i++;
}
echo '<input type="radio" name="poller_mode" value="IP" '; if (strtolower($settings['misc']['poller_mode'])=='ip') echo('checked');  echo '>Use these Network settings for polling ThermIQ-Wlan<br>';
echo '<input type="text" name="IP Address" value="'.$ip[1].'" size="40" maxlength="75" tabindex="12" style="width:191px;height:22px;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;color:#000000;background-color:#FFFFFF;">&nbsp;IP Addres (i.e 192.168.1.100)</br>';
echo '<input type="text" name="IP Port" value="'.$ip[2].'" size="40" maxlength="75" tabindex="12" style="width:191px;height:22px;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;color:#000000;background-color:#FFFFFF;">&nbsp;IP Port, default 2000</br>';
echo '<input type="text" name="IP User" value="'.$ip[3].'" size="40" maxlength="75" tabindex="12" style="width:191px;height:22px;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;color:#000000;background-color:#FFFFFF;">&nbsp;IP Username, default is empty</br>';
echo '<input type="text" name="IP Password" value="'.$ip[4].'" size="40" maxlength="75" tabindex="12" style="width:191px;height:22px;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;color:#000000;background-color:#FFFFFF;">&nbsp;IP Password, default is empty </br></br>';

echo '</br></div></div></br>';


// Telldus
if (isset($settings['Telldus']['poller_telldusduo'])){
echo '<div class="valuePanel" id="pollers" style="position:relative;z-index:2;left:10px;width:840px;background:#F0F0F0;border-width:1;border-style:solid;border-color:#FF0000;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;">'."\n";
echo '<div id="pollers.1" style="position:relative;z-index:27;left:10px;top:10px;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;text-align////:left;color:#000000;">';
echo 'Telldus poller:<br><br>';
echo '<input type="checkbox" name="Telldus_poll" value="ON"';if ($settings['Telldus']['poller_telldusduo']=='1') echo('checked'); echo '>Enable polling of Telldus temperature sensors<br>';
echo '</br>';
echo 'tdtool_path&nbsp;<input type="text" name="tdtool_path" value="'.$settings['Telldus']['tdtool_path'].'" size="240" maxlength="145" tabindex="12" style="width:291px;height:22px;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;color:#000000;background-color:#FFFFFF;"></br>Normaly <b>tdtool</b> for Linux and <b>c:\program files\Telldus\tdtool.exe</b> for windows</br>';
echo '</br></div></div></br>';
}
// ElectrIQ
if (isset($settings['ElectrIQ']['poller_ElectrIQ'])){
echo '<div class="valuePanel" id="pollers2" style="position:relative;z-index:2;left:10px;width:840px;background:#F0F0F0;border-width:1;border-style:solid;border-color:#FF0000;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;">'."\n";
echo '<div id="pollers2.1" style="position:relative;z-index:27;left:10px;top:10px;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;text-align////:left;color:#000000;">';
echo 'Electricity poller:<br><br>';
echo '<input type="checkbox" name="EL_poll" value="ON"';if ($settings['ElectrIQ']['poller_ElectrIQ']=='1') echo('checked'); echo '>Enable polling of electric meter through ElectrIQ<br>';

echo '</br>';
echo '<input type="text" name="EL_Ticks" value="'.$settings['ElectrIQ']['TicksPerWatt'].'" size="40" maxlength="45" tabindex="12" style="width:91px;height:22px;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;color:#000000;background-color:#FFFFFF;">&nbsp;Ticks per kWh. Default is 1000</br>';
echo "<br>";

$ip=explode(":",$settings['ElectrIQ']['ip_device']);
$i=1;
while ($i<5) {
	if (!isset($ip[$i]) ) {
		$ip[$i]='';
	}
		$i++;
}
echo '<input type="text" name="EL_Address" value="'.$ip[1].'" size="40" maxlength="75" tabindex="12" style="width:191px;height:22px;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;color:#000000;background-color:#FFFFFF;">&nbsp;IP Addres (i.e 192.168.1.100)</br>';
echo '<input type="text" name="EL_Port" value="'.$ip[2].'" size="40" maxlength="75" tabindex="12" style="width:191px;height:22px;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;color:#000000;background-color:#FFFFFF;">&nbsp;IP Port, default 2000</br>';
echo '<input type="text" name="EL_User" value="'.$ip[3].'" size="40" maxlength="75" tabindex="12" style="width:191px;height:22px;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;color:#000000;background-color:#FFFFFF;">&nbsp;IP Username, default is empty</br>';
echo '<input type="text" name="EL_Password" value="'.$ip[4].'" size="40" maxlength="75" tabindex="12" style="width:191px;height:22px;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;color:#000000;background-color:#FFFFFF;">&nbsp;IP Password, default is empty </br></br>';

echo '</br></div></div><br>';
}
 		
// AirIQ
if (isset($settings['AirIQ']['poller_AirIQ'])){
echo '<div class="valuePanel" id="pollers3" style="position:relative;z-index:2;left:10px;width:840px;background:#F0F0F0;border-width:1;border-style:solid;border-color:#FF0000;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;">'."\n";
echo '<div id="pollers3.1" style="position:relative;z-index:27;left:10px;top:10px;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;text-align////:left;color:#000000;">';
echo 'Thermiavent (AirIQ) poller:<br><br>';
echo '<input type="checkbox" name="AIR_poll" value="ON"';if ($settings['AirIQ']['poller_AirIQ']=='1') echo('checked'); echo '>Enable polling of ThermiaVent through AirIQ<br>';

echo '</br>';

$ip=explode(":",$settings['AirIQ']['ip_device']);
$i=1;
while ($i<5) {
	if (!isset($ip[$i]) ) {
		$ip[$i]='';
	}
		$i++;
}
echo '<input type="text" name="AIR_Address" value="'.$ip[1].'" size="40" maxlength="75" tabindex="12" style="width:191px;height:22px;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;color:#000000;background-color:#FFFFFF;">&nbsp;IP Addres (i.e 192.168.1.100)</br>';
echo '<input type="text" name="AIR_Port" value="'.$ip[2].'" size="40" maxlength="75" tabindex="12" style="width:191px;height:22px;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;color:#000000;background-color:#FFFFFF;">&nbsp;IP Port, default 2000</br>';
echo '<input type="text" name="AIR_User" value="'.$ip[3].'" size="40" maxlength="75" tabindex="12" style="width:191px;height:22px;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;color:#000000;background-color:#FFFFFF;">&nbsp;IP Username, default is empty</br>';
echo '<input type="text" name="AIR_Password" value="'.$ip[4].'" size="40" maxlength="75" tabindex="12" style="width:191px;height:22px;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;color:#000000;background-color:#FFFFFF;">&nbsp;IP Password, default is empty </br></br>';

echo '</br></div></div></br>';
}
echo '</form>
<br>';

 		if (isset($wrote_inifile) && ($wrote_inifile<>"")) {
 			echo "<hr>Global settings saved to ".$wrote_inifile."<br>"; 
       if (isset($outlog)) {
					echo $outlog;
				}
				echo '<br><hr>';
 		}	
 		
echo('<br></body>
</html>');

?>