<?php 
/* SVN FILE: $Id: settings_update.php 493 2014-01-20 22:26:23Z anders $
* Project Name : ThermIQ*
* @version $Revision: 493 $
* @lastrevision $Date: 2014-01-20 23:26:23 +0100 (mån, 20 jan 2014) $
* @modifiedby $LastChangedBy: anders $
* @lastmodified $LastChangedDate: 2014-01-20 23:26:23 +0100 (mån, 20 jan 2014) $
*/
include_once('../init.php');
    

// Date format
$dateformat = "Y-m-d H:i:s";       // Date format. Here are some other examples (that you can combine) :
                                   // "M D, Y"   = Dec Fri, 2002
                                   // "m/d/y"    = 12/20/02
                                   // "m-d-y"    = 12-20-02
                                   // "l M d, Y" = Friday Dec 20, 2002
                                   // "F dS, Y"  = December 20th, 2002
                                   // "H:i:s"    = 24 hour time with seconds
                                   // "h:i a"    = 12 hour time with am,pm
                                   // etc...

// Header
		header("Expires: -1");
		header("Pragma: no-cache");
		header("Cache-Control: max-age=0");
		header("Cache-Control: no-cache");
		header("Cache-Control: no-store");
		header("Content-Type: text/html; charset=iso-8859-1");


		echo "\n<html>";
		echo "\n<head>";
		echo "<meta name=\"revised\" content=\"\$Revision: 493 $\" />";
		
		echo "\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">";
		echo "\n<title>".$ui_string['settings']['page_name']."</title>";
		echo "\n<style type=\"text/css\" media=screen>";
		echo "\n<!--";
		echo "\ntd         { background-color: #F0F0F0; color: #000000; font-family: Arial, Helvetica, sans-serif; font-size: 10pt; }";
		echo "\n-->";
		echo "\n</style>";

		
		echo "\n</head>";
		$sel_page=9;
		include('toplinks.php');
		
// Table
		echo '<div id="Panel" style="position:relative;z-index:0;left:0px;top:20px;width:955px;background-color:#f0f0f0;border:2px outset grey;">'."\n";
		echo '<b>'.$ui_string['settings']['update_tbl'];
		echo "</b><br>".date($dateformat).'<br></div><br><br>';


// Buttons
	  echo '<INPUT STYLE="width:130" TYPE="BUTTON" VALUE="'.$ui_string['settings']['back_btn'].'" NAME="CANCEL"';
    echo " ONCLICK=\"location.href='settings.php';return false;\"><br>";
    if ($admin) {

   function read_ini_filex($f)
    {global $r;
        $null = "";
        $r=$null;
        $first_char = "";
        $sec=$null;
        $comment_chars=";#";
        $num_comments = "0";
        $num_newline = "0";

        //Read to end of file with the newlines still attached into $f
        $f = @file($f);
        if ($f === false) {
            return -2;
        }
        // Process all lines from 0 to count($f)
        for ($i=0; $i<@count($f); $i++)
        {
            $w=@trim($f[$i]);
            $first_char = @substr($w,0,1);
            if ($w)
            {
                if ((@substr($w,0,1)=="[") and (@substr($w,-1,1))=="]") {
                    $sec=@substr($w,1,@strlen($w)-2);
                    $num_comments = 0;
                    $num_newline = 0;
                }
                else if ((stristr($comment_chars, $first_char) == true)) {
                    $r[$sec]["Comment_".$num_comments]=$w;
                    $num_comments = $num_comments +1;
                }               
                else {
                    // Look for the = char to allow us to split the section into key and value
                    $w=@explode("=",$w);
                    $k=@trim($w[0]);
                    unset($w[0]);
                    $v=@trim(@implode("=",$w));
                    // look for the new lines
                    if ((@substr($v,0,1)=="\"") and (@substr($v,-1,1)=="\"")) {
                        $v=@substr($v,1,@strlen($v)-2);
                    }
                   
                    $r[$sec][$k]=$v;
                   
                }
            }
            else {
                $r[$sec]["Newline_".$num_newline]=$w;
                $num_newline = $num_newline +1;
            }
        }
        return 1;
    }


    function write_ini_filex($path, $assoc_arr) {
        $content = "";

        foreach ($assoc_arr as $key=>$elem) {
            if (is_array($elem)) {
                if ($key != '') {
                    $content .= "[".$key."]\r\n";                   
                }
               
                foreach ($elem as $key2=>$elem2) {
                    if (beginsWith($key2,'Comment_') == 1 && beginsWith($elem2,';')) {
                        $content .= $elem2."\r\n";
                    }
                    else if (beginsWith($key2,'Newline_') == 1 && ($elem2 == '')) {
                        $content .= $elem2."\r\n";
                    }
                    else {
                        $content .= $key2." = ".$elem2."\r\n";
                    }
                }
            }
            else {
                $content .= $key." = ".$elem."\r\n";
            }
        }

        if (!$handle = fopen($path, 'w')) {
            return -2;
        }
        if (!fwrite($handle, $content)) {
            return -2;
        }
        fclose($handle);
        return 1;
    }

    function beginsWith( $str, $sub ) {
        return ( substr( $str, 0, strlen( $sub ) ) === $sub );
    }



   function print_r2($val){
        echo '<pre>';
        print_r($val);
        echo  '</pre>';
		}

if (!empty($_POST)) {
	//print_r2($_POST);
	$upd_link='';
	$load_beta=FALSE;
	$upd_switches='';
	if (isset($_POST['PERM'])) {
		$upd_link='http://www.thermiq.net/ThermIQ_Client/update_client';
	} else {
		if (isset($_POST['BETA'])) {
			$upd_link='http://www.thermiq.net/ThermIQ_beta/update_client';
			echo "beta</br>\n";
			$load_beta=TRUE;
			$upd_switches=' -b';
		}
	}


	if (($upd_link<>'') && (file_exists_incpath('poller') )) {
			$dest_dir=dirname(realpath(file_exists_incpath('poller')));
			if(!@copy($upd_link,$dest_dir."/update_client"))
			{
			    $errors= error_get_last();
			    echo "COPY ERROR: ".$errors['type'];
			    echo "<br />\n".$errors['message']."<br>";
			} else {
			    echo "<b>Update script copied from remote!</b><br>";
			    echo '<b>When done, go to <a href="check_install.php">check_install.php</a></b><br>Executing downloaded update script<br>';
			    chmod(file_exists_incpath('update_client'),0755);
			    if (strstr(php_uname('a'),'raspberrypi')) {
						exec('sudo /usr/sbin/update_client'.$upd_switches,$outlog);
					} else {
	        	exec($php_prepend.'update_client'.$upd_switches,$outlog);
	        }
                echo '<textarea  name="UserList" rows="32" cols="151"  tabindex="13" style="font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;color:#000000;background-color:#FFFFFF;">';
        	foreach ($outlog as $row) 
                {
			echo $row ."\n";
		}
                echo '</textarea>';


			}
			
	}
        exit();
} 

	
echo '<script type="text/javascript"></script><noscript><strong><br><span style="color:red">Your browser either does not support JavaScript or it is turned off.';
echo '<br>Without Javascript enabled, this form will not function correctly</strong></span></noscript>';


	if (file_exists_incpath('poller') ) {
			$bin_dir=dirname(realpath(file_exists_incpath('poller')));
	}

	$file_handle = fopen($bin_dir.DIRECTORY_SEPARATOR."..".DIRECTORY_SEPARATOR."..".DIRECTORY_SEPARATOR."RevisionLog.txt", "rb");
        if ($file_handle === false) {
	   echo '<b>Local release:</b>&nbsp;&nbsp;0 - RevisionLog.txt not found<br>';
           $local_rev="0";
        } else { 
	$lt = fgets($file_handle);
	$local=explode(':',$lt);
        $local_rev=trim(trim($local[1]));
	echo '<b>Local release:</b>&nbsp;&nbsp;'.$local_rev.'<br>';
	fclose($file_handle);
        }
	
  $php_post=file_get_contents('http://www.thermiq.net/check_thermiq_version.php?uid='.urlencode($settings['thermiq']['user_id']).'&date='.urlencode(date($dateformat)).'&local_version='.urlencode(trim($local_rev)).'&local_os='.urlencode(php_uname('a')));
  if ($php_post === false ) {
    
    echo '<b>Server release:</b>&nbsp;0 - Unable to conact www.thermiq.net. Check your IP settings (DNS and Gateway)<br>';
  } else {

	$server_version=explode("\n",$php_post);
	
//print_r2($server_version);
	$server=explode(':',$server_version[0]);
        $server_rev=trim($server[1]);
   
	echo '<b>Server release:</b>&nbsp;'.$server_rev.'<br>';

if ($local_rev<$server_rev) {
	echo '<form name="New_Form" action="settings_update.php" method="POST" enctype="application/x-www-form-urlencoded">';
   echo '<INPUT STYLE="width:130" TYPE="SUBMIT" onClick="return confirm(\'Please do a backup of the hpdb database before any update. '. $ui_string['settings']['warn_update'].'\');" VALUE="'.$ui_string['settings']['update_btn'].'" NAME="PERM">';
	 echo "</form>";
echo '<br><b>Diff:</b><br>';
echo '<textarea  name="UserList" rows="15" cols="151"  tabindex="13" style="font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;color:#000000;background-color:#FFFFFF;">';
	print $php_post;	


echo '</textarea>';
} else {
	echo '<span style="color:green">Local release is up to date</span>'."\n";
	
	echo "<br><br><br>Reload files anyway?";
	echo '<form name="New_Form" action="settings_update.php" method="POST" enctype="application/x-www-form-urlencoded">'."\n";
	echo '<INPUT STYLE="width:130" TYPE="SUBMIT" onClick="return confirm(\'Please do a backup of the hpdb database before any update. '. $ui_string['settings']['warn_update'].'\');" VALUE="'.$ui_string['settings']['update_btn'].'" NAME="PERM">';
	echo "</form>\n";

 $php_post=file_get_contents('http://www.thermiq.net/check_thermiq_version.php?uid='.urlencode($settings['thermiq']['user_id']).'&date='.urlencode(date($dateformat)).'&local_version=beta'.'&local_os='.urlencode(php_uname('a')));
	if ($php_post === false) {
	} else {

		$server_beta=explode("\n",$php_post);
		$server=explode(':',$server_beta[0]);
		$beta_rev=trim($server[1]);
		
		echo '</br></br></br><span style="color:red"><b>Beta release:</b>&nbsp;'.$beta_rev.' is avail. Install beta?<br>'."\n";
		echo '<b>Note: </b>Beta releases might be unstable and there\'s no automatic rollback to stable!!</br>'."\n";
		echo '<b>Note: </b>Always make a backup of your database before going beta!!</br></span>'."\n";
		
		
		echo '<form name="New_Form" action="settings_update.php" method="POST" enctype="application/x-www-form-urlencoded">'."\n";
		echo '<INPUT STYLE="width:130" TYPE="SUBMIT" onClick="return confirm(\'Please do a backup of the hpdb database before any update. '. $ui_string['settings']['warn_update'].'\');" VALUE="Install beta?" NAME="BETA">';
		echo "</form>";
		echo '<br><b>Diff:</b><br>';
		echo '<textarea  name="UserList" rows="15" cols="151"  tabindex="13" style="font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;color:#000000;background-color:#FFFFFF;">';
		print $php_post;	
		echo '</textarea>';
	}

}
}
}
?>
</body>
</html>


