<?php
/* SVN FILE: $Id: widget_current.php 455 2013-07-07 19:54:58Z anders $
* Project Name : ThermIQ*
* @version $Revision: 455 $
* @lastrevision $Date: 2013-07-07 21:54:58 +0200 (s, 07 jul 2013) $
* @modifiedby $LastChangedBy: anders $
* @lastmodified $LastChangedDate: 2013-07-07 21:54:58 +0200 (s, 07 jul 2013) $
*/

if ($widget_op == "settings") {
// Settings part of gadget
// Called from settings_gadget.php


echo "&nbsp;Main fuse value&nbsp;&nbsp;&nbsp;&nbsp;<input type=\"text\" name=\"".$this_func.'_fuse" value="'.$wdg_fuse."\" size=\"1\" maxlength=\"4\" tabindex=\"25\" style=\"position:relative;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;color:#000000;background-color:#FFFFFF;\">A<br>";
echo "<br>";

}

if ($widget_op == "visible" && $ElectrIQ_poll) {
	if (is_numeric($wdg_fuse)) {
		$max_power=intval(($wdg_fuse*0.4*1.73)+1)*1000;
	} else $max_power=14000;
	$red_power=$max_power*2/3;
	$yellow_power=$max_power/2;
	$watts=0;
	$peak=0;
	$elTime= date("Y-m-d H:i:s");
  foreach($permdb->query("select TID, EL, DT FROM RAWSTORE WHERE (DT<>\"\" AND DT >0 )ORDER BY TID DESC LIMIT 1") as $row) {
		extract($row);

		//print_r($row);

 $watts=$row[1]*60;
 $peak=0;


 if ($row[2]<>0) $peak=$row[1]*60*60/$row[2];
 $elTime= date("Y-m-d H:i:s",$row[0]);
}

echo "\n<canvas width=130 height=145 id=\"El_canvas\"></canvas>

<script type=\"text/javascript\" src=\"RODial.js\"></script>
<script type=\"text/javascript\">
var nReading = $watts;
var nArrow = 1;
var sParams = \"title=El;arrow=\"+nArrow+\";min=0;ll=0;l=0;h=$yellow_power;hh=$red_power;max=$max_power;val=\"+nReading
+\";display=\"+nReading+\" W;display2=$elTime\";
try
{
drawDialGauge('El_canvas',sParams);
} catch(err)
{
// handle possible errors here, or just ignore them
}
</script>";



 
}

if ($widget_op == "init") {
	echo "init";
	//Clear old settings associated with this widget
	foreach ($permdb->query("select * FROM WIDGETS WHERE (WIDGET=\"".$this_func."\")") as $row){
		$permdb->exec('delete from WIDGETS where KEYNAME="'.$row['KEYNAME'].'"');
				     //echo('delete from WIDGETS where KEYNAME="'.$row['KEYNAME'].'"<br>');
	}
//$permdb->beginTransaction();
$permdb->exec('REPLACE INTO WIDGETS (KEYNAME,WIDGET,ITEM,VALUE) VALUES("'.$this_func.'_visible", "'.$this_func.'", "visible", "false")');	
$permdb->exec('REPLACE INTO WIDGETS (KEYNAME,WIDGET,ITEM,VALUE) VALUES("'.$this_func.'_top", "'.$this_func.'", "top", "200px")');	
$permdb->exec('REPLACE INTO WIDGETS (KEYNAME,WIDGET,ITEM,VALUE) VALUES("'.$this_func.'_left", "'.$this_func.'", "left", "700px")');	
$permdb->exec('REPLACE INTO WIDGETS (KEYNAME,WIDGET,ITEM,VALUE) VALUES("'.$this_func.'_fuse", "'.$this_func.'", "fuse", "20")');	
$permdb->exec('REPLACE INTO WIDGETS (KEYNAME,WIDGET,ITEM,VALUE) VALUES("'.$this_func.'_ticks", "'.$this_func.'", "ticks", "1000")');	
$permdb->exec('REPLACE INTO WIDGETS (KEYNAME,WIDGET,ITEM,VALUE) VALUES("'.$this_func.'_height", "'.$this_func.'", "height", "")');	
//				 echo('REPLACE INTO WIDGETS (KEYNAME,WIDGET,ITEM,VALUE) VALUES("'.$this_func.'_visible", "'.$this_func.'", "visible", "false")');	
//$permdb->commit();
}

?>