#!/opt/bin/php
<?php

function getDirectoryList ($directory) 
  {

    // create an array to hold directory list
    $results = array();

    // create a handler for the directory
    $handler = opendir($directory);

    // open directory and walk through the filenames
    while ($file = readdir($handler)) {

      // if file isn't this directory or its parent, add it to the results
      if ($file != "." && $file != "..") {
        $results[] = $file;
      }

    }

    // tidy up: close the handler
    closedir($handler);

    // done!
    return $results;

  }
  
   
		// List of all files needed for performing update
		// This scripts assumes an already working installation and no changes in 
		// outside of php scripts and ini files.
		
		
		$local_dir	=$_GET['dir'];
		//echo $local_dir."\n\n";
		$res="";

		$Gdir='';

		if ($local_dir == 'opt') {
			$files=getDirectoryList("./common/opt/etc/");
		} else
		if ($local_dir == 'bin') {
			$files=getDirectoryList("./common/usr/sbin/");
		} else
		if ($local_dir == 'html') {
			$files=getDirectoryList("./common/webcontent/html/");
			$imgfiles=getDirectoryList("./common/webcontent/html/img/");
			$res.= "img/";
			$res.=(implode(',img/',$imgfiles));
			$res.= ',../init.php_,';
		} else exit;
		$res.=implode(',',$files);
		echo $res;		
			
?>
