<?php 
/* SVN FILE: $Id: fix_languages.php 329 2012-11-28 20:44:28Z anders $
* Project Name : ThermIQ*
* @version $Revision: 329 $
* @lastrevision $Date: 2012-11-28 21:44:28 +0100 (ons, 28 nov 2012) $
* @modifiedby $LastChangedBy: anders $
* @lastmodified $LastChangedDate: 2012-11-28 21:44:28 +0100 (ons, 28 nov 2012) $
*/
include_once('../init.php');
    

// Header
		header("Expires: -1");
		header("Pragma: no-cache");
		header("Cache-Control: max-age=0");
		header("Cache-Control: no-cache");
		header("Cache-Control: no-store");
		header("Content-Type: text/html; charset=iso-8859-1");


		echo "\n<html>";
		echo "\n<head>";
		echo "<meta name=\"revised\" content=\"\$Revision: 329 $\" />";
		
		echo "\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">";
		echo "\n<title>".$ui_string['settings']['page_name']."</title>";
		echo "\n<style type=\"text/css\" media=screen>";
		echo "\n<!--";
		echo "\ntd         { background-color: #F0F0F0; color: #000000; font-family: Arial, Helvetica, sans-serif; font-size: 10pt; }";
		echo "\n-->";
		echo "\n</style>";

		
		echo "\n</head>";


   function read_ini_filex($f,&$r)
    {
        $null = "";
        $r=$null;
        $first_char = "";
        $sec=$null;
        $comment_chars=";#";
        $num_comments = "0";
        $num_newline = "0";

        //Read to end of file with the newlines still attached into $f
        $f = @file($f);
        if ($f === false) {
            return -2;
        }
        // Process all lines from 0 to count($f)
        for ($i=0; $i<@count($f); $i++)
        {
            $w=@trim($f[$i]);
            $first_char = @substr($w,0,1);
            if ($w)
            {
                if ((@substr($w,0,1)=="[") and (@substr($w,-1,1))=="]") {
                    $sec=@substr($w,1,@strlen($w)-2);
                    $num_comments = 0;
                    $num_newline = 0;
                }
                else if ((stristr($comment_chars, $first_char) == true)) {
                    $r[$sec]["Comment_".$num_comments]=$w;
                    $num_comments = $num_comments +1;
                }               
                else {
                    // Look for the = char to allow us to split the section into key and value
                    $w=@explode("=",$w);
                    $k=@trim($w[0]);
                    unset($w[0]);
                    $v=@trim(@implode("=",$w));
                    // look for the new lines
                    if ((@substr($v,0,1)=="\"") and (@substr($v,-1,1)=="\"")) {
                        $v=@substr($v,1,@strlen($v)-2);
                    }
                   
                    $r[$sec][$k]=$v;
                   
                }
            }
            else {
                $r[$sec]["Newline_".$num_newline]=$w;
                $num_newline = $num_newline +1;
            }
        }
        return 1;
    }


    function write_ini_filex($path, $assoc_arr,$en,$de,$no) {
        $content = "";
        $indx="";

        foreach ($assoc_arr as $key=>$elem) {
            if (is_array($elem)) {
                if ($key != '') {
                    $content .= "[".$key."]\r\n";
                    $indx=$key;                   
                }
               
                foreach ($elem as $key2=>$elem2) {
                    if (beginsWith($key2,'Comment_') == 1 && beginsWith($elem2,';')) {
                        $content .= $elem2."\r\n";
                    }
                    else if (beginsWith($key2,'Newline_') == 1 && ($elem2 == '')) {
                        $content .= $elem2."\r\n";
                    }
                    else {
			                if ($indx<>"") {
			                	$content .= $key2."\t".$elem2."\t".$en[$indx][$key2]."\t".$de[$indx][$key2]."\t".$no[$indx][$key2]."\r\n";
			                } else {
			                	$content .= $key2."\t".$elem2."\t".$en[$key2]."\t".$de[$key2]."\t".$no[$key2]."\r\n";
			                }
                    }
                }
            }
            else {
                if ($indx<>"") {
                	$content .= $key."\t".$elem."\t".$en[$indx][$key]."\t".$de[$indx][$key]."\t".$no[$indx][$key]."\r\n";
                } else {
                	$content .= $key."\t".$elem."\t".$en[$key]."\t".$de[$key]."\t".$no[$key]."\r\n";
                }
            }
        }

        if (!$handle = fopen($path, 'w')) {
            return -2;
        }
        if (!fwrite($handle, $content)) {
            return -2;
        }
        fclose($handle);
        return 1;
    }

    function beginsWith( $str, $sub ) {
        return ( substr( $str, 0, strlen( $sub ) ) === $sub );
    }



   function print_r2($val){
        echo '<pre>';
        print_r($val);
        echo  '</pre>';
		}
echo "Hej";
	read_ini_filex("c:/xampp/opt/etc/Thermiq_sw.ini",$se);
	read_ini_filex("c:/xampp/opt/etc/Thermiq_en.ini",$en);
	read_ini_filex("c:/xampp/opt/etc/Thermiq_no.ini",$no);
	read_ini_filex("c:/xampp/opt/etc/Thermiq_de.ini",$de);
	write_ini_filex("c:/xampp/opt/etc/Thermiq_lang.csv",$se,$en,$de,$no);
	print_r2($se);
	print_r2($de);


?>

</body>
</html>


