<?php 
/* SVN FILE: $Id: settings_global.php 481 2014-01-12 15:37:05Z anders $
* Project Name : ThermIQ*
* @version $Revision: 481 $
* @lastrevision $Date: 2014-01-12 16:37:05 +0100 (sön, 12 jan 2014) $
* @modifiedby $LastChangedBy: anders $
* @lastmodified $LastChangedDate: 2014-01-12 16:37:05 +0100 (sön, 12 jan 2014) $
*/
include_once('../init.php');
    

// Date format
$dateformat = "Y-m-d H:i:s";       // Date format. Here are some other examples (that you can combine) :
                                   // "M D, Y"   = Dec Fri, 2002
                                   // "m/d/y"    = 12/20/02
                                   // "m-d-y"    = 12-20-02
                                   // "l M d, Y" = Friday Dec 20, 2002
                                   // "F dS, Y"  = December 20th, 2002
                                   // "H:i:s"    = 24 hour time with seconds
                                   // "h:i a"    = 12 hour time with am,pm
                                   // etc...

// Header
		header("Expires: -1");
		header("Pragma: no-cache");
		header("Cache-Control: max-age=0");
		header("Cache-Control: no-cache");
		header("Cache-Control: no-store");
		header("Content-Type: text/html; charset=iso-8859-1");


		echo "\n<html>";
		echo "\n<head>";
		echo "<meta name=\"revised\" content=\"\$Revision: 481 $\" />";
		
		echo "\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">";
		echo "\n<title>".$ui_string['settings']['page_name']."</title>";
		echo "\n<style type=\"text/css\" media=screen>";
		echo "\n<!--";
		echo "\ntd         { background-color: #F0F0F0; color: #000000; font-family: Arial, Helvetica, sans-serif; font-size: 10pt; }";
		echo "\n-->";
		echo "\n</style>";
		echo "<LINK href=\"style.css\" rel=\"stylesheet\" type=\"text/css\">\n";

		
		echo "\n</head>";
		$sel_page=9;
		include('toplinks.php');
		
		
// Table
		echo '<div id="Panel" style="position:relative;z-index:0;left:0px;top:20px;width:955px;background-color:#f0f0f0;border:2px outset grey;">'."\n";
		echo '<b>'.$ui_string['settings']['globals_tbl'];
		echo "</b><br>".date($dateformat).'<br></div><br><br>';


// Buttons
	  echo '<INPUT STYLE="width:130" TYPE="BUTTON" VALUE="'.$ui_string['settings']['back_btn'].'" NAME="CANCEL"';
    echo " ONCLICK=\"location.href='settings.php';return false;\"><br>";
$wrote_inifile='';
    if ($admin) {

   function read_ini_filex($f)
    {global $r;
        $null = "";
        $r=$null;
        $first_char = "";
        $sec=$null;
        $comment_chars=";#";
        $num_comments = "0";
        $num_newline = "0";

        //Read to end of file with the newlines still attached into $f
        $f = @file($f);
        if ($f === false) {
            return -2;
        }
        // Process all lines from 0 to count($f)
        for ($i=0; $i<@count($f); $i++)
        {
            $w=@trim($f[$i]);
            $first_char = @substr($w,0,1);
            if ($w)
            {
                if ((@substr($w,0,1)=="[") and (@substr($w,-1,1))=="]") {
                    $sec=@substr($w,1,@strlen($w)-2);
                    $num_comments = 0;
                    $num_newline = 0;
                }
                else if ((stristr($comment_chars, $first_char) == true)) {
                    $r[$sec]["Comment_".$num_comments]=$w;
                    $num_comments = $num_comments +1;
                }               
                else {
                    // Look for the = char to allow us to split the section into key and value
                    $w=@explode("=",$w);
                    $k=@trim($w[0]);
                    unset($w[0]);
                    $v=@trim(@implode("=",$w));
                    // look for the new lines
                    if ((@substr($v,0,1)=="\"") and (@substr($v,-1,1)=="\"")) {
                        $v=@substr($v,1,@strlen($v)-2);
                    }
                   
                    $r[$sec][$k]=$v;
                   
                }
            }
            else {
                $r[$sec]["Newline_".$num_newline]=$w;
                $num_newline = $num_newline +1;
            }
        }
        return 1;
    }


    function write_ini_filex($path, $assoc_arr) {
        $content = "";

        foreach ($assoc_arr as $key=>$elem) {
            if (is_array($elem)) {
                if ($key != '') {
                    $content .= "[".$key."]\r\n";                   
                }
               
                foreach ($elem as $key2=>$elem2) {
                    if (beginsWith($key2,'Comment_') == 1 && beginsWith($elem2,';')) {
                        $content .= $elem2."\r\n";
                    }
                    else if (beginsWith($key2,'Newline_') == 1 && ($elem2 == '')) {
                        $content .= $elem2."\r\n";
                    }
                    else {
                        $content .= $key2." = ".$elem2."\r\n";
                    }
                }
            }
            else {
                $content .= $key." = ".$elem."\r\n";
            }
        }

        if (!$handle = fopen($path, 'w')) {
            return -2;
        }
        if (!fwrite($handle, $content)) {
            return -2;
        }
        fclose($handle);
        return 1;
    }

    function beginsWith( $str, $sub ) {
        return ( substr( $str, 0, strlen( $sub ) ) === $sub );
    }



   function print_r2($val){
        echo '<pre>';
        print_r($val);
        echo  '</pre>';
		}

$wrote_inifile="";
if (!empty($_POST)) {

	if (strstr(php_uname('s'),'Linux')) {
		$filename=$opt_path.'Thermiq_Linux.ini';
	}
	else if(strstr(php_uname('s'),'Windows')) {
			$filename=$opt_path.'Thermiq_Windows.ini';	
	} else {
		echo "<br><b>Unknown OS, nothing is changed:</b></br>";
	} 

 	//foreach($_POST as $key => $value) echo($key.'  '.$value.'<br>');

  $passwd=array();
  $admrights=array(); 
	$passwd['Comment_1'] 		= "; List of usernames and password pairs";
  $passwd['Comment_2'] 		= "; username = password";
	$admrights['Comment_1'] = "; This is the list of user rigths:";  
  $admrights['Comment_2']= "; user is a regular user, admin is admin";

  
  $pwl=explode("\n",$_POST['UserList']);
  foreach($pwl as $pos=> $uidpwd) {
		$myuid=explode("=",$uidpwd);
		if ($myuid[0]<>'' && $myuid[1]<>'') {
			$passwd[trim($myuid[0])]=trim($myuid[1]);
			if (isset($_POST['user'.$pos])&& ($_POST['user'.$pos]=='admin')) {
				$admrights[$myuid[0]] = 'admin';
				//echo $myuid[0]." = admin<br>";
			} else {
				$admrights[$myuid[0]] = 'user';
				//echo $myuid[0]." = user<br>";			
			}
		}
  }

  $passwd['Newline_0'] = '';
  $passwd['Newline_1'] = '';
  $admrights['Newline_0'] = '';
  $admrights['Newline_1'] = '';
  
 	read_ini_filex($filename);
 
 	$r['thermiq']['hp_type'] = $_POST['hp_type'];
 	$r['thermiq']['compressor_power'] = $_POST['compressor_power'];
 	
 	$r['thermiq']['language'] ='';
 	if ($_POST['language']<>"") {
 		$r['thermiq']['language'] = "\"".$_POST['language']."\"";
 	}
 	
 	$r['thermiq']['user_id'] ='';
 	if ($_POST['user_id']<>"") {
 		$r['thermiq']['user_id'] = "\"".$_POST['user_id']."\"";
 	}
 	
 	
 	$r['passwd']= $passwd;
 	$r['rights']= $admrights;

 	$r['database']['temporary'] = $_POST['temporary'];
 	$r['database']['permanent'] = $_POST['permanent'];

	$r['misc']['tempdir']= $_POST['tempdir'];
	$r['misc']['permdir']= $_POST['permdir'];
	$r['misc']['php_exec']= $_POST['php_exec'];
	$r['misc']['php_scriptpath']= $_POST['php_scriptpath'];

	if(isset($_POST['mail_system'])) {
	$r['misc']['mail_system']= $_POST['mail_system'];
	} else {
		$r['misc']['mail_system']= '';	
	}

	write_ini_filex($filename,$r);
	$wrote_inifile=$filename;
 	if ($r['thermiq']['hp_type']!=$settings['thermiq']['hp_type']) {
 		exec($php_prepend .'mkdbtemplate',$outlog);
 		$this_output="<b>mkdbtemplate</b></br>";
 		foreach ($outlog as $row) {
				$this_output.= $row ."</br>";
		}

 		$outlog=$this_output;
 	}

	include('../init.php'); 

}	
	
	
}
	
echo '<script type="text/javascript">'."\n";
echo 'function New_Form_WithoutContent(ss){'."\n";
echo '  if (ss.length>0){return false;}'."\n";
echo 'return true;'."\n";
echo '}'."\n";
echo 'function New_Form_WithoutCheck(ss){'."\n";
echo '  if(ss.checked){return false;}'."\n";
echo 'return true;'."\n";
echo '}'."\n";
echo 'function New_Form_NumberCheck(ss){'."\n";
echo '  if(isNaN(ss)){'."\n".'return true;}'."\n";
echo 'return false;'."\n";
echo '}'."\n";
echo 'function New_Form_CF(){'."\n";
echo 'var errormessage = new String();'."\n";
echo 'var vF = document.forms["New_Form"];'."\n";
echo 'if(New_Form_WithoutContent(vF["UserList"].value)){errormessage += "\n\nPlease fill in the \"UserList\" text area";}
if(New_Form_WithoutContent(vF["user_id"].value)){errormessage += "\n\nPlease fill in the \"User ID\" text area";}'."\n";
echo 'if(New_Form_NumberCheck(vF["compressor_power"].value)){errormessage += "\n\nPlease enter a number for the compressor power using . as decimal separator";}'."\n";
echo 'if (errormessage.length > 2){'."\n";
echo '    alert("There are errors or ommissions in the form" + errormessage + "\n");';
echo '    return false;';
echo '    } return true;';
echo '} // end of New_Form_CF() ';

echo '</script>'."\n";
echo '<noscript><strong><br><span style="color:red">Your browser either does not support JavaScript or it is turned off.'."\n";
echo '<br>Without Javascript enabled, this form will not function correctly</span></strong></noscript><br>'."\n";
// Form and Buttons
echo '<form name="New_Form" action="settings_global.php" method="POST" enctype="application/x-www-form-urlencoded" onsubmit="return New_Form_CF();">'."\n";
echo '<input type="submit" onClick="return confirm(\'Really save settings?\');" name="submitBtn" value="Save" tabindex="1" style="position:relative;z-index:4;width:130px;height:24px;">';
echo '<input type="reset" name="resetBtn" value="reset" tabindex="2" style="position:relative;z-index:5;left:30px;width:130px;height:24px;">';

echo '<div class="settings_global"  style="position:relative;z-index:4;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;"></br>';
// Global panels

		echo '<div class="valuePanel" style="left:10px;width:840px;border:2px outset grey;background:#F0F0F0;">'."\n";
		echo '<div class="valuePanelcontent" style="position:relative;left:20px;">'."\n";
		echo '<div class="valuePanelcontenthalf" style="float:left;width:350px;">'."\n";
		echo "<b>". $ui_string['settings']['user_id']." </b>\n";

// User id
		echo '<div id="paneltext">';
		echo "<input type=\"text\" name=\"user_id\" value=\"".$settings['thermiq']['user_id']."\" size=\"75\" maxlength=\"75\" tabindex=\"25\" style=\"left:20px;width:270px;height:22px;\">";
		echo "</div></br>";	

		// HP-type
		echo '<div id="panelreadio">';
		echo '<input type="radio" name="hp_type" value="Diplomat" ';if (strtolower($settings['thermiq']['hp_type'])=='diplomat') echo('checked'); echo '>Diplomat</br>';
		echo '<input type="radio" name="hp_type" value="Optimum" '; if (strtolower($settings['thermiq']['hp_type'])=='optimum') echo('checked');  echo '>Optimum</br>';
		echo '<input type="radio" name="hp_type" value="OptimumG2" ';if (strtolower($settings['thermiq']['hp_type'])=='optimumg2') echo('checked');echo '>Optimum G2/Optimum G3</br></br>';
		echo '&nbsp;Compressor power. &nbsp;&nbsp;<input type="text" name="compressor_power" value=';echo($settings['thermiq']['compressor_power']);echo ' size="4" maxlength="4" tabindex="22" style="width:34px;height:22px;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;color:#000000;background-color:#FFFFFF;">&nbsp;kW';
		echo '</div></div>';


// Language
		echo '<div class="valuePanelcontenthalf" style="float:right;width:350px;">'."\n";
		echo "<b>&nbsp GUI Language </b></br>\n";
echo '<input type="radio" name="language" value=""   '; if ($settings['thermiq']['language']=='')               echo('checked');echo '>Browser default<br>';
echo '<input type="radio" name="language" value="se" '; if (strtolower($settings['thermiq']['language'])=='sw') echo('checked');echo '>Svenska<br>';
echo '<input type="radio" name="language" value="en" '; if (strtolower($settings['thermiq']['language'])=='en') echo('checked');echo '>English<br>';
echo '<input type="radio" name="language" value="de" '; if (strtolower($settings['thermiq']['language'])=='de') echo('checked');echo '>Deutsch<br>';
echo '<input type="radio" name="language" value="no" '; if (strtolower($settings['thermiq']['language'])=='no') echo('checked');echo '>Norsk<br>';
echo '<input type="radio" name="language" value="fi" '; if (strtolower($settings['thermiq']['language'])=='fi') echo('checked');echo '>Suomi<br>';
echo '</div><br style="clear:both;"></br></div></div>';


// Userlist
		echo '<br><div class="valuePanel" style="left:10px;width:840px;border:2px outset grey;background:#F0F0F0;">'."\n";
		echo "<b>&nbsp Userlist </b></br>\n";
		echo '<div class="valuePanelcontent" style="position:relative;left:20px;height:200px;"></br>'."\n";
echo 'Admin&nbsp;&nbsp;Username=Password';
echo '<div class="valuePanelcontentpwd" style="position:relative;">'."\n";
echo ''."\n".'<textarea name="UserList" rows="8" cols="43" tabindex="13" style="position:absolute;left:45px;top:10px;width:350px;height:135px;">';
	$user=array();$i=0; 
	foreach($settings['passwd'] as $key=>$val) {
		$user[$i]=''; echo($key.' = '.$val."\n"); 
		if ($settings['rights'][$key]=='admin' ) {
			$user[$i]='checked';
		}
		$i++;  
	}
echo '</textarea>';

for ($i=0;$i<8;$i++) {
  echo '</br><input type="checkbox" name="user'.$i.'" value="admin"'; 
	if (isset($user[$i])) echo $user[$i]; 
	echo ' tabindex="'.(14+$i). '" style="position:absolute;left:10px;top:'. (12+16*$i) .'px;width:14px;height:14px;">';

}

echo '</div></div></div>';
echo "</div></div>";


// Php paths
		echo '<br><div class="valuePanel" style="left:10px;width:840px;border:2px outset grey;background:#F0F0F0;">'."\n";
		echo "<b>&nbsp;". $ui_string['settings']['php_path']." </b></br>\n";
		echo '<div class="valuePanelcontent" style="position:relative;left:20px;">'."\n";
		echo '<div class="valuePanelcontenthalf" style="float:left;width:350px;">'."\n";
		echo 'php.exe path:<br>';
		echo "<input type=\"text\" name=\"php_exec\" value=\"".$settings['misc']['php_exec']."\" size=\"40\" maxlength=\"80\" tabindex=\"25\" style=\"width:240px;height:22px;\"></div>";
		echo '<div class="valuePanelcontenthalf" style="float:right;width:350px;">'."\n";
		echo "php script path:</br>";
echo "<input type=\"text\" name=\"php_scriptpath\" value=\"".$settings['misc']['php_scriptpath']."\" size=\"40\" maxlength=\"80\" tabindex=\"26\" style=\"width:240px;height:22px;\">";
echo '</div><br style="clear:both;"></br></div></div>';



// DAtabases etc
		echo '<br><div class="valuePanel" style="left:10px;width:840px;border:2px outset grey;background:#F0F0F0;">'."\n";
		echo "<b>&nbsp Databases </b></br>\n";
		echo '<div class="valuePanelcontent" style="position:relative;left:20px;"></br>'."\n";
		echo '<div class="valuePanelcontenthalf" style="float:left;width:350px;">'."\n";
		echo 'Temporary database name<br><input type="text" name="temporary" value=';echo($settings['database']['temporary']);echo ' size="40" maxlength="80" tabindex="22" style="width:240px;height:22px;"></br>';
		echo 'Permanent database name<br><input type="text" name="permanent" value=';echo($settings['database']['permanent']);echo ' size="40" maxlength="80" tabindex="23" style="width:240px;height:22px;"></br></div>';

		echo '<div class="valuePanelcontenthalf" style="float:right;width:350px">'."\n";
echo 'Temporary directory<br><input type="text" name="tempdir" value=';
echo('"'.$settings['misc']['tempdir'].'"');
		echo ' size="40" maxlength="55" tabindex="27" style="width:240px;height:22px;"><br>';
echo 'Permanent directory<br><input type="text" name="permdir" value=';
echo('"'.$settings['misc']['permdir'].'"');
		echo ' size="40" maxlength="55" tabindex="28" style="width:240px;height:22px;">';
		echo '</div><br style="clear:both;"></br></div></div>';



    

echo '</form></div></div></div>';
 		echo("<hr>");
 		if ($wrote_inifile<>"") {
 			echo "Global settings saved to ".$wrote_inifile."<br>"; 
       if (isset($outlog)) {
					echo $outlog;
				}
 		}	
echo '</body></html>';
?>

