<?php 
/* SVN FILE: $Id: settings_widgets.php 462 2013-12-09 22:49:32Z anders $
* Project Name : ThermIQ*
* @version $Revision: 462 $
* @lastrevision $Date: 2013-12-09 23:49:32 +0100 (mån, 09 dec 2013) $
* @modifiedby $LastChangedBy: anders $
* @lastmodified $LastChangedDate: 2013-12-09 23:49:32 +0100 (mån, 09 dec 2013) $
*/
include_once('../init.php');
    

// Date format
$dateformat = "Y-m-d H:i:s";       // Date format. Here are some other examples (that you can combine) :
                                   // "M D, Y"   = Dec Fri, 2002
                                   // "m/d/y"    = 12/20/02
                                   // "m-d-y"    = 12-20-02
                                   // "l M d, Y" = Friday Dec 20, 2002
                                   // "F dS, Y"  = December 20th, 2002
                                   // "H:i:s"    = 24 hour time with seconds
                                   // "h:i a"    = 12 hour time with am,pm
                                   // etc...

// Header
		header("Expires: -1");
		header("Pragma: no-cache");
		header("Cache-Control: max-age=0");
		header("Cache-Control: no-cache");
		header("Cache-Control: no-store");
		header("Content-Type: text/html; charset=iso-8859-1");


		echo "\n<html>";
		echo "\n<head>";
		echo "<meta name=\"revised\" content=\"\$Revision: 462 $\" />";		
		echo "\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">";
		echo "\n<title>".$ui_string['settings']['page_name']."</title>";
		echo "\n<style type=\"text/css\" media=screen>";
		echo "\n<!--";
		echo "\ntd         { background-color: #F0F0F0; color: #000000; font-family: Arial, Helvetica, sans-serif; font-size: 10pt; }";
		echo "\n-->";
		echo "\n</style>";
		echo "<LINK href=\"style.css\" rel=\"stylesheet\" type=\"text/css\">\n";

		
		echo "\n</head>";
		echo '<script type="text/JavaScript" src="curvycorners.js"></script>'."\n";
		$sel_page=10;
		include('toplinks.php');
		
// Table
		echo '<div id="Panel" style="position:relative;z-index:0;left:0px;top:20px;width:955px;background-color:#f0f0f0;border:2px outset grey;">'."\n";
		echo '<b>'."Select and Configure gadgets";//$ui_string['settings']['gadgets_config'];
		echo "</b><br>".date($dateformat).'<br></div><br><br>';


// Buttons
	  echo '<INPUT STYLE="width:130" TYPE="BUTTON" VALUE="'.$ui_string['settings']['back_btn'].'" NAME="CANCEL"';
    echo " ONCLICK=\"location.href='settings.php';return false;\"><br>\n";

    if ($admin) {
// Buttons
    	
  function read_ini_filex($f)
    {global $r;
        $null = "";
        $r=$null;
        $first_char = "";
        $sec=$null;
        $comment_chars=";#";
        $num_comments = "0";
        $num_newline = "0";

        //Read to end of file with the newlines still attached into $f
        $f = @file($f);
        if ($f === false) {
            return -2;
        }
        // Process all lines from 0 to count($f)
        for ($i=0; $i<@count($f); $i++)
        {
            $w=@trim($f[$i]);
            $first_char = @substr($w,0,1);
            if ($w)
            {
                if ((@substr($w,0,1)=="[") and (@substr($w,-1,1))=="]") {
                    $sec=@substr($w,1,@strlen($w)-2);
                    $num_comments = 0;
                    $num_newline = 0;
                }
                else if ((stristr($comment_chars, $first_char) == true)) {
                    $r[$sec]["Comment_".$num_comments]=$w;
                    $num_comments = $num_comments +1;
                }               
                else {
                    // Look for the = char to allow us to split the section into key and value
                    $w=@explode("=",$w);
                    $k=@trim($w[0]);
                    unset($w[0]);
                    $v=@trim(@implode("=",$w));
                    // look for the new lines
                    if ((@substr($v,0,1)=="\"") and (@substr($v,-1,1)=="\"")) {
                        $v=@substr($v,1,@strlen($v)-2);
                    }
                   
                    $r[$sec][$k]=$v;
                   
                }
            }
            else {
                $r[$sec]["Newline_".$num_newline]=$w;
                $num_newline = $num_newline +1;
            }
        }
        return 1;
    }


    function write_ini_filex($path, $assoc_arr) {
        $content = "";

        foreach ($assoc_arr as $key=>$elem) {
            if (is_array($elem)) {
                if ($key != '') {
                    $content .= "[".$key."]\r\n";                   
                }
               
                foreach ($elem as $key2=>$elem2) {
                    if (beginsWith($key2,'Comment_') == 1 && beginsWith($elem2,';')) {
                        $content .= $elem2."\r\n";
                    }
                    else if (beginsWith($key2,'Newline_') == 1 && ($elem2 == '')) {
                        $content .= $elem2."\r\n";
                    }
                    else {
                        $content .= $key2." = ".$elem2."\r\n";
                    }
                }
            }
            else {
                $content .= $key." = ".$elem."\r\n";
            }
        }

        if (!$handle = fopen($path, 'w')) {
            return -2;
        }
        if (!fwrite($handle, $content)) {
            return -2;
        }
        fclose($handle);
        return 1;
    }

    function beginsWith( $str, $sub ) {
        return ( substr( $str, 0, strlen( $sub ) ) === $sub );
    }


	include('../init.php'); 

if (!empty($_POST)) {
echo "POST:";
print_r($_POST);
			$permdb->exec('UPDATE WIDGETS SET VALUE="false" WHERE ITEM="visible"');	
 	foreach($_POST as $key => $value) {
 		//print_r($_POST);
 		//echo('POST:'.$key.'  '.$value.'<br>');
		//$r['gadgets'][$key]= "\"".urlencode($value)."\"";
		if ($key!="submitBtn"){
			if ($value=="_forceInit") {
				$permdb->exec('DELETE FROM WIDGETS WHERE KEYNAME="'.$key.'"');
			} else {
			$permdb->exec('UPDATE WIDGETS SET VALUE="'.$value.'" WHERE KEYNAME="'.$key.'"');	
 	      //echo("<br>".'UPDATE WIDGETS SET VALUE="'.$value.'" WHERE KEYNAME="'.$key.'")');
 	    }	
		}
	}
}

echo '<script type="text/javascript"></script><noscript><strong><br><span style="color:red">Your browser either does not support JavaScript or it is turned off.';
echo '<br>Without Javascript enabled, this form will not function correctly</strong></span></noscript>';

echo "\n\n";

echo '<form name="New_Form" action="settings_widgets.php" method="POST" enctype="application/x-www-form-urlencoded">';
echo "\n\n";
echo '<input type="submit" onClick="return confirm(\'Really save settings?\');" name="submitBtn" value="Save" tabindex="1" style="position:absolute;z-index:4;width:130px;height:24px;"><br>';
echo "</br>\n\n";
echo "Hints: You can move and place the Widgets on the index-page</br>\n";
echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;You can create your own widgets by using widget_test.php as base</br></br>\n";

foreach ( glob('widget_*.php') as $file)
	{
$this_func=basename($file,".php");
		echo "\n<!====================================================================";
		echo "\n  === Widget: ". $this_func;
		echo "\n  ====================================================================>\n";

		echo '<div class="valuePanel" style="position:relative;z-index:2;left:10px;width:840px;background:#F0F0F0;border-width:1;border-style:solid;border-color:#FF0000;font-size:10pt;font-family:Arial;font-weight:normal;font-style:normal;">'."\n";
		echo '<b>&nbsp;'.$this_func."</b>&nbsp;&nbsp;&nbsp;&nbsp;\n";

// Check if gadget is already installed
		foreach($permdb->query("SELECT COUNT(*) FROM WIDGETS WHERE (ITEM=\"visible\" AND WIDGET=\"".$this_func."\")") as $row){
		if ($row['COUNT(*)']!=1) {
			$widget_op="init";
				echo "init\n";
			include $file;
		}
		}
		// Set widget variables from database		
		echo "<!====  Widget variables from database ===============================\n";
	foreach ($permdb->query('select ITEM, VALUE FROM WIDGETS WHERE (WIDGET="'.$this_func.'")') as $row){
			if ($row['ITEM']!="") {
				parse_str("wdg_".$row['ITEM'].'='.$row['VALUE']);
				echo "wdg_".$row['ITEM'].'='.$row['VALUE']."\n";
	}
		
		}
		echo "========================================================================>\n\n";
		

		echo "\n".'</br><input type="radio" name="'.$this_func.'_visible" value="true" onChange="submit();" '; 
		if ($wdg_visible=="true") {
		 echo 'checked'; 
		}
echo ' style="position:width:14px;height:14px;">Enabled'; 

		echo "\n".'<input type="radio" name="'.$this_func.'_visible" value="false" onChange="submit();" '; 
		if ($wdg_visible=="false") {
		 echo 'checked'; 
		}
echo ' style="position:width:14px;height:14px;">Disabled'; 

		echo "\n".'<input type="radio" name="'.$this_func.'_visible" value="_forceInit" onChange="submit();" '; 
		echo ' style="position:width:14px;height:14px;">Reset</br><br>'."\n"; 

		
		$widget_op="settings";
		include $file;
		
		echo "\n</input><br></div><br>\n";
	}


}

?>
</form>
</body>
</html>